%% Darwin et al. 1994

clear;

fs=44100;

f0=155; 
% f0=400;
arm= [1 10];
duration=0.5;
condicion= 'silencio';

currentF= pwd;
currentF=currentF(1:length(currentF)-17);
currentF=strcat(currentF,'wavFileStore');


mistHarm=4;
mistunings= [0, 0.016, 0.032, 0.048, 0.064, 0.080, 0.113];

numTones= length(mistunings);

for i=1:numTones,
    MistPercent= mistunings(i);

    [m, signal] = ComplexToneMistuned(duration, fs, f0, arm, 0, condicion, 1, 'sine', mistHarm, MistPercent);

    currentFolder = fullfile(currentF, 'Mistuned', 'M');

    name= strcat('MistunedTone(', num2str(f0), 'Hz)', num2str(floor(1000*MistPercent)), '.wav');
    filename= fullfile(currentFolder, name);
    audiowrite(filename, signal, fs);

end


% Generate reference complex tones stimuli

% f0s= (f0)*0.9:0.1:(f0)*1.1;
f0s= [140.0:154.0 154.5:0.1:156.5 157.0:170.0];

for i=1:length(f0s),
    [m, tone]= ComplexTone(duration, fs, f0s(i), arm, 0, condicion, 1, 'sine', 'no', 0);
    currentFolder = fullfile(currentF, 'Mistuned', 'Ref');
    name= strcat('ReferenceTone(', num2str(10*f0s(i)), 'Hz).wav');
    filename= fullfile(currentFolder, name);
    audiowrite(filename, tone, fs);
end