% Stimuli corresponding to Plomp (1976): Dominance region
% m=1,2,3,4,5,6
% f0=200,300,450,675


clear;
duration=0.5; %0.5
condicion= 'silencio';
fs=44100;
f0= [200, 300, 450, 675];
armnum=12;
m=1:12;

currentF= pwd;
currentF=currentF(1:length(currentF)-17);
currentF=strcat(currentF,'wavFileStore');
outputFolder = fullfile(currentF, 'Dominance');    

f0len= length(f0);
mlen=length(m);

for i=1:f0len,
    for j=1:mlen,
        arm1=[1,m(j)];
        arm2=[m(j)+1,armnum];
        [t,sin1]=ComplexToneNoNorm( duration, fs, round(0.9*f0(i)), arm1, 0, 'silence', 1, 'sine', 'no', 0);
        [t,sin2]=ComplexToneNoNorm( duration, fs, round(1.1*f0(i)), arm2, 0, 'silence', 1, 'sine', 'no', 0);
        tone=sin1+sin2;
        tone=tone/max(tone);
        if m(j)<10
            name= strcat('Dominance(', num2str(f0(i)), 'Hz)0', num2str(m(j)), '.wav');
        else
            name= strcat('Dominance(', num2str(f0(i)), 'Hz)', num2str(m(j)), '.wav');
        end
        filename= fullfile(outputFolder, name);
        audiowrite(filename, tone, fs);
        
%         wsize= floor(10*fs/f0(i));
%         [ empty,f,t0,P ] = spectrogram( tone, rectwin(wsize), round(wsize/2), wsize, fs );
%         P2= mean(P,2);
%         P2=P2(f<f0(i)*14);
%         f=f(f<f0(i)*14);
%         plot(f,P2)
%         grid on
        
    end  
end
