% Patterson & Wightman (1976)
% Shift of all components in a complex
% 100 Hz tone shifted in 25 Hz steps
% number of lowest harmonic also varies

clear;
duration=0.5; %0.5
condicion= 'silencio';
fs=44100;
f0= 100;
shifts= [-45 -35 -25 -15 -5 0 5 15 25 35 45];
nArm=6;

numStimuli= length(shifts)*12;

currentF= pwd;
currentF=currentF(1:length(currentF)-17);
currentF=strcat(currentF,'wavFileStore');


for i=0:numStimuli-1,
    shift = shifts(mod(i,11) + 1);
    lowestHarm= floor(i/11) + 1; 
    arm= [lowestHarm (lowestHarm -1  + nArm)];
    [m, shiftedTone] = ComplexTone(duration, fs, f0, arm, shift, condicion, 1, 'sine', 'noFilter', 0);
    
    currentFolder = fullfile(currentF, 'Shifted', 'S');
    name= strcat('ShiftedTone(', num2str(f0), 'Hz)Hn=', num2str(lowestHarm), 'shift=', num2str(shift), '.wav');
    filename= fullfile(currentFolder, name);
    audiowrite(filename, shiftedTone, fs);
    
    wsize= floor(10*fs/f0);

%     [ empty,f,t0,P ] = spectrogram( shiftedTone, rectwin(wsize), round(wsize/2), wsize, fs );
%     P2= mean(P,2);
%     P2=P2(f<1500);
%     f=f(f<1500);
%     plot(f,P2)
%     grid on
    
end


% Reference tones

f0s= 90:110;
arm= [1 10];
for i=1:length(f0s),
    f0=f0s(i);
    [m, refTone] = ComplexTone(duration, fs, f0, arm, 0, condicion, 1, 'sine', 'noFilter', 0);
    
    currentFolder = fullfile(currentF, 'Shifted', 'Ref');
    name= strcat('RefTone(', num2str(f0), 'Hz)', '.wav');
    filename= fullfile(currentFolder, name);
    audiowrite(filename, refTone, fs);
    
%     wsize= floor(10*fs/f0);
% 
%     [ empty,f,t0,P ] = spectrogram( refTone, rectwin(wsize), round(wsize/2), wsize, fs );
%     P2= mean(P,2);
%     P2=P2(f<1500);
%     f=f(f<1500);
%     plot(f,P2)
%     grid on

    
end